/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: Condition.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_CONDITION_HPP_
#define _TOPS_CONDITION_HPP_

#include "tops/attribute/AttributesOfCondition.hpp"
#include "tops/object/Object.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	class Condition;
	typedef boost::shared_ptr<Condition> ConditionPtr;
	class Fact;

	/**
	 * 条件です。
	 *
	 * @author トゥイー
	 */
	class Condition : public Object {
	private:
		/**
		 * ラベルです。
		 */
		std::string m_label;

		/**
		 * 属性列です。
		 */
		AttributesOfCondition m_attributes;

	public:
		/**
		 * 属性の無い条件を構築します。
		 *
		 * @param name 条件の名前を指定します。
		 * @param label ラベルを指定します。
		 */
		Condition(const std::string& name, const std::string& label=std::string()) :
		Object(name), m_label(label) {
		}

		/**
		 * 条件を構築します。
		 *
		 * @param name 条件の名前を指定します。
		 * @param attributes 条件となる属性列を指定します。
		 * @param label ラベルを指定します。
		 */
		Condition(const std::string& name,
		          const AttributesOfCondition& attributes,
		          const std::string& label=std::string()) :
		Object(name), m_label(label), m_attributes(attributes) {
		}

	public:
		/**
		 * ラベル付けされているかどうかを判断します。
		 *
		 * @return ラベル付けされている場合はtrueを、されていない場合はfalseを返します。
		 */
		bool isLabeled() const {
			return !m_label.empty();
		}

		/**
		 * ラベルを取得します。
		 */
		const std::string& getLabel() const {
			return m_label;
		}

	public:
		/**
		 * 指定された事実と単一化を行います。
		 *
		 * @param fact 単一化対象となる事実を指定します。
		 * @param element 単一化済み要素を指定します。
		 * @param variables 単一化に使用する変数表を指定します。
		 *
		 * @return 単一化に成功した場合は単一化済み属性列を、失敗した場合はNULLを返します。
		 */
		UnificatedAttributesPtr unificate(const Fact& fact, Variables& variables);

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
